highp float rand(highp vec2 x){
	return fract(sin(dot(x, vec2(14.56, 56.2))) * 20000.);
}

highp float noise(highp vec2 x){
	highp vec2 ipos = floor(x);
	highp vec2 fpos = fract(x);
	fpos = smoothstep(0., 1., fpos);
	float a = rand(ipos), b = rand(ipos + vec2(1, 0)),
		c = rand(ipos + vec2(0, 1)), d = rand(ipos + 1.);
 return mix(a, b, fpos.x) + (c - a) * fpos.y * (1.0 - fpos.x) + (d - b) * fpos.x * fpos.y;
}

vec2 rotate(vec2 v, float a) {
	float s = sin(a);
	float c = cos(a);
	mat2 m = mat2(c, -s, s, c);
	return m * v;
}

vec3 saturation(vec3 x, float y){
    vec3 getLuminance = vec3(dot(x, vec3(.299, 
      .5, .7)));
return mix(getLuminance, x, y);
}